import os.path
import os
import shutil

class DirectoryNotFoundException(Exception):
	
	def __init__(self,directory):
		Exception.__init__(self)
		self.directory = directory
	
	def getDirectory():
		return self.directory

class CharacterLoader:
	
	#Gender
	MALE = 'Male'
	FEMALE = 'Female'
	
	#Age
	CHILD = 'child'
	ADULT = 'adult'
	GRANNY = 'granny'
	
	#Type
	CASUAL = 'casual'
	BUSINESS = 'business'
	SPORTIVE = 'sportive'
	NUDE = 'nude'
	NONE = ''
	
	#Poly
	LOWPOLY = 'lowpoly'
	MEDIUMPOLY = 'mediumpoly'
	HIGHPOLY = 'highpoly'
	
	RESOURCEURL = "C:\\Program Files\\WorldViz\\Vizard30\\resources\\"
	
	def __init__(self,directory):
		if len(directory) <= 0:
			raise DirectoryNotFoundException(directory)
		else:
			self.directory = directory
			if os.path.isdir(self.directory):
				pass #everything is oke
			else:
				os.mkdir(self.directory)
		
	def getAvatar(self,gender,age,type,avatarNumber,poly):
		base = self.RESOURCEURL
		avatarDirectory = base+''+gender
		
		
		if gender == self.MALE:
			avatarAnimationDirectory = base+''+gender+'\\'+age+'\\_'+poly+'\\'
			os.path.walk(avatarAnimationDirectory,self.copyFiles,poly)
			avatarDirectory += '\\'+age+'\\'
			avatarDirectory += type+''+avatarNumber+'_m\\'
			os.path.walk(avatarDirectory,self.copyFiles,poly)
			
			if age == self.CHILD:
				return age+''+avatarNumber+'_m_'+poly+'.cfg'
			else:
				return type+''+avatarNumber+'_m_'+poly+'.cfg'
			
		elif gender == self.FEMALE:
			if age == self.ADULT:
				ageDir = 'adult_flatheels'
				if type == self.CASUAL:
					try:
						casualList = ['01','02','03','04','16','17','18','23','24','25','26']
						casualList.index(avatarNumber)
					except:
						ageDir = 'adult_highheels'
				elif type == self.BUSINESS:
					ageDir = 'adult_highheels'
				
				avatarAnimationDirectory = base+''+gender+'\\'+ageDir+'\\_'+poly+'\\'
				os.path.walk(avatarAnimationDirectory,self.copyFiles,poly)
				
				avatarDirectory += '\\'+ageDir+'\\'+type+''+avatarNumber+'_f\\'
				os.path.walk(avatarDirectory,self.copyFiles,poly)
				
				return type+''+avatarNumber+'_f_'+poly+'.cfg'
			elif age == self.GRANNY:
				avatarAnimationDirectory = base+gender+'\\'+age+'\\_'+poly+'\\'
				os.path.walk(avatarAnimationDirectory,self.copyFiles,poly)
				
				
				avatarDirectory += '\\'+age+'\\'
				avatarDirectory += type+''+avatarNumber+'\\'
				os.path.walk(avatarDirectory,self.copyFiles,poly)
				
				if age == self.ADULT:
					return type+''+avatarNumber+'_'+poly+'.cfg'
					
				else:
					return age+''+avatarNumber+'_'+poly+'.cfg'
			else:
				avatarAnimationDirectory = base+gender+'\\'+age+'\\_'+poly+'\\'
				os.path.walk(avatarAnimationDirectory,self.copyFiles,poly)
				
				
				avatarDirectory += '\\'+age+'\\'
				avatarDirectory += type+''+avatarNumber+'_f\\'
				os.path.walk(avatarDirectory,self.copyFiles,poly)
				
				if age == self.ADULT:
					return type+''+avatarNumber+'_f_'+poly+'.cfg'
					
				else:
					return age+''+avatarNumber+'_f_'+poly+'.cfg'
			
	
	def copyFiles(self,arg,dir,fileList):
		for file in fileList:
			fullf = os.path.join(dir,file)
			if os.path.isfile(fullf):
				if file.find(arg) or file.find('.tga'):
					shutil.copy(fullf,self.directory)

#ch = CharacterLoader('G:\Temp\Avatars')
#
#print ch.getAvatar(ch.FEMALE,ch.GRANNY,ch.NONE,'02',ch.MEDIUMPOLY)
#print ch.getAvatar(ch.FEMALE,ch.ADULT,ch.CASUAL,'06',ch.LOWPOLY)
#print ch.getAvatar(ch.MALE,ch.ADULT,ch.BUSINESS,'02',ch.HIGHPOLY)
#print ch.getAvatar(ch.MALE,ch.CHILD,ch.NONE,'02',ch.MEDIUMPOLY)
#
#		
#			
			
		
		
		
		